﻿using System;

namespace TabSaver.MenuItems
{
    /// <summary>
    /// This is a sample for menuitem starting an executable.
    /// It'll appear in the menu to the very right where all the extra tools are located.
    /// To start an executable it is required to have the ExecutePath property set.
    /// </summary>
    public class MenuItemLoadFrom : SpicIE.Controls.MenuItem
    {
        /// <summary>
        /// The PluginGuid _must_ be a unique GUID to identify and register the COM object correctly
        /// </summary>
        public override string PluginGuid
        {
            get { return "BAAC7D2D-9A4C-4c9a-9BD4-CC4815B129FF"; }
        }

        /// <summary>
        /// The PluginProgID _must_ be provided to identify and register the COM object correctly
        /// </summary>
        public override string PluginProgID
        {
            get { return "TabSaver.MenuItemLoadFrom"; }
        }

        public MenuItemLoadFrom()
        {
            this.MenuItemName = "Load saved Tabs...";

            // can be shown either in help or tools menu
            this.MenuItemCustom = MenuItemCustomEnum.Tools;

            this.MenuStatusBar = "Load all Tabs that were saved previously";
            this.MenuItemCommand = MenuItemCommandEnum.COMObject;
            // specifies the path to an executable and starts it
            this.AssociatedCLSIDExtension = new Guid("45123456-9A4C-4cac-9BD4-CC4815B28333");
        }
    }
}
