﻿using System;

namespace TabSaver.MenuItems
{
    /// <summary>
    /// This is a sample for menuitem starting an executable.
    /// It'll appear in the menu to the very right where all the extra tools are located.
    /// To start an executable it is required to have the ExecutePath property set.
    /// </summary>
    public class MenuItemSaveAs : SpicIE.Controls.MenuItem
    {
        /// <summary>
        /// The PluginGuid _must_ be a unique GUID to identify and register the COM object correctly
        /// </summary>
        public override string PluginGuid
        {
            get { return "BAAC7D2D-104C-4c9a-9BD4-CC4815B229AA"; }
        }

        /// <summary>
        /// The PluginProgID _must_ be provided to identify and register the COM object correctly
        /// </summary>
        public override string PluginProgID
        {
            get { return "TabSaver.MenuItemSaveAs"; }
        }

        public MenuItemSaveAs()
        {
            this.MenuItemName = "Save open Tabs...";

            // can be shown either in help or tools menu
            this.MenuItemCustom = MenuItemCustomEnum.Tools;
            this.MenuStatusBar = "Save all Tabs that are opened in the current window";
            this.MenuItemCommand = MenuItemCommandEnum.COMObject;
            // specifies the path to an executable and starts it
            this.AssociatedCLSIDExtension = new Guid("456C7EED-9A4C-4c9a-9BD4-CC4815B28333");
        }
    }
}
