﻿using System;

namespace TabSaver.MenuItems
{
    /// <summary>
    /// This is a sample for menuitem starting an executable.
    /// It'll appear in the menu to the very right where all the extra tools are located.
    /// To start an executable it is required to have the ExecutePath property set.
    /// </summary>
    public class MenuItemLoad : SpicIE.Controls.MenuItem
    {
        /// <summary>
        /// The PluginGuid _must_ be a unique GUID to identify and register the COM object correctly
        /// </summary>
        public override string PluginGuid
        {
            get { return "ECDBB080-E314-452a-BA6D-69DCFAE520A7"; }
        }

        /// <summary>
        /// The PluginProgID _must_ be provided to identify and register the COM object correctly
        /// </summary>
        public override string PluginProgID
        {
            get { return "TabSaver.MenuItemLoad"; }
        }

        public MenuItemLoad()
        {
            this.MenuItemName = "Quick Load saved Tabs";

            // can be shown either in help or tools menu
            this.MenuItemCustom = MenuItemCustomEnum.Tools;

            this.MenuStatusBar = "Quick Load all Tabs that were saved previously";
            this.MenuItemCommand = MenuItemCommandEnum.COMObject;
            // specifies the path to an executable and starts it
            this.AssociatedCLSIDExtension = new Guid("09AFB878-CC96-42bc-9ED7-6CD62C3C10BF");
        }
    }
}
