﻿using System;

namespace TabSaver.MenuItems
{
    /// <summary>
    /// This is a sample for menuitem starting an executable.
    /// It'll appear in the menu to the very right where all the extra tools are located.
    /// To start an executable it is required to have the ExecutePath property set.
    /// </summary>
    public class MenuItemSave : SpicIE.Controls.MenuItem
    {
        /// <summary>
        /// The PluginGuid _must_ be a unique GUID to identify and register the COM object correctly
        /// </summary>
        public override string PluginGuid
        {
            get { return "BEC13B2E-4A8B-44ad-85BF-EBC076E9A4EF"; }
        }

        /// <summary>
        /// The PluginProgID _must_ be provided to identify and register the COM object correctly
        /// </summary>
        public override string PluginProgID
        {
            get { return "TabSaver.MenuItemSave"; }
        }

        public MenuItemSave()
        {
            this.MenuItemName = "Quick Save open Tabs";

            // can be shown either in help or tools menu
            this.MenuItemCustom = MenuItemCustomEnum.Tools;
            this.MenuStatusBar = "Quick Save all Tabs that are opened in the current window";
            this.MenuItemCommand = MenuItemCommandEnum.COMObject;
            // specifies the path to an executable and starts it
            this.AssociatedCLSIDExtension = new Guid("87EBBA22-E898-4743-A2A8-08D760A087F9");
        }
    }
}
