﻿using System;

namespace TabSaver.MenuItems
{
    /// <summary>
    /// This is a sample for menuitem starting an executable.
    /// It'll appear in the menu to the very right where all the extra tools are located.
    /// To start an executable it is required to have the ExecutePath property set.
    /// </summary>
    public class MenuItemSaveAs : SpicIE.Controls.MenuItem
    {
        /// <summary>
        /// The PluginGuid _must_ be a unique GUID to identify and register the COM object correctly
        /// </summary>
        public override string PluginGuid
        {
            get { return "347AC3CA-573D-4c79-B0B5-3DAF3ECEB140"; }
        }

        /// <summary>
        /// The PluginProgID _must_ be provided to identify and register the COM object correctly
        /// </summary>
        public override string PluginProgID
        {
            get { return "TabSaver.MenuItemSaveAs"; }
        }

        public MenuItemSaveAs()
        {
            this.MenuItemName = "Save open Tabs...";

            // can be shown either in help or tools menu
            this.MenuItemCustom = MenuItemCustomEnum.Tools;
            this.MenuStatusBar = "Save all Tabs that are opened in the current window";
            this.MenuItemCommand = MenuItemCommandEnum.COMObject;
            // specifies the path to an executable and starts it
            this.AssociatedCLSIDExtension = new Guid("356E734C-2C24-4e81-8266-31F155D291FE");
        }
    }
}
